clang-tools 10.0.0

Public Member Functions | Public Attributes | List of all members
clang::doc::Info Struct Reference

A base struct for Infos. More...

`#include <Representation.h>`

Inheritance diagram for clang::doc::Info:
[legend]
Collaboration diagram for clang::doc::Info:
[legend]

## Public Member Functions
| Info ()=default
| Info (InfoType IT)
| Info (InfoType IT, SymbolID USR)
| Info (InfoType IT, SymbolID USR, StringRef Name)
| Info (InfoType IT, SymbolID USR, StringRef Name, StringRef Path)
| Info (const Info &Other)=delete
| Info (Info &&Other)=default
virtual | ~Info ()=default
void | mergeBase (Info &&I)
bool | mergeable (const Info &Other)
llvm::SmallString< 16 > | extractName () const
llvm::Expected< Reference > | getEnclosingScope ()

## Public Attributes
SymbolID | USR
const InfoType | IT = InfoType::IT_default
SmallString< 16 > | Name
llvm::SmallVector< Reference, 4 > | Namespace
std::vector< CommentInfo > | Description
llvm::SmallString< 128 > | Path

## Detailed Description

A base struct for Infos.

Definition at line 237 of file Representation.h.

## Constructor & Destructor Documentation

## ◆ Info() [1/7]

clang::doc::Info::Info | ( |  | ) |
| default

## ◆ Info() [2/7]

clang::doc::Info::Info | ( | InfoType | IT | ) |
| inline

Definition at line 239 of file Representation.h.

## ◆ Info() [3/7]

clang::doc::Info::Info | ( | InfoType | IT,
|  | SymbolID | USR
| ) |  |
| inline

Definition at line 240 of file Representation.h.

## ◆ Info() [4/7]

clang::doc::Info::Info | ( | InfoType | IT,
|  | SymbolID | USR,
|  | StringRef | Name
| ) |  |
| inline

Definition at line 241 of file Representation.h.

## ◆ Info() [5/7]

clang::doc::Info::Info | ( | InfoType | IT,
|  | SymbolID | USR,
|  | StringRef | Name,
|  | StringRef | Path
| ) |  |
| inline

Definition at line 243 of file Representation.h.

## ◆ Info() [6/7]

clang::doc::Info::Info | ( | const Info & | Other | ) |
| delete

## ◆ Info() [7/7]

clang::doc::Info::Info | ( | Info && | Other | ) |
| default

## ◆ ~Info()

virtual clang::doc::Info::~Info | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ extractName()

llvm::SmallString< 16 > clang::doc::Info::extractName | ( |  | ) | const

Definition at line 218 of file Representation.cpp.

References clang::doc::IT_default, clang::doc::IT_enum, clang::doc::IT_function, clang::doc::IT_namespace, clang::doc::IT_record, clang::doc::Reference::Name, and clang::doc::Reference::USR.

Referenced by clang::doc::Generator::addInfoToIndex().

## ◆ getEnclosingScope()

llvm::Expected<Reference> clang::doc::Info::getEnclosingScope | ( |  | ) |

## ◆ mergeable()

bool clang::doc::Info::mergeable | ( | const Info & | Other | ) |

Definition at line 149 of file Representation.cpp.

References IT, clang::doc::Reference::USR, and USR.

## ◆ mergeBase()

void clang::doc::Info::mergeBase | ( | Info && | I | ) |

Definition at line 131 of file Representation.cpp.

References Description, clang::doc::Reference::mergeable(), clang::doc::Reference::Name, clang::doc::Reference::Path, and clang::doc::Reference::USR.

## Member Data Documentation

## ◆ Description

std::vector<CommentInfo> clang::doc::Info::Description

Definition at line 256 of file Representation.h.

Referenced by clang::doc::ClangDocBitcodeWriter::emitBlock(), clang::doc::getCommentInfo(), llvm::yaml::InfoMapping(), and clang::doc::serialize::populateInfo().

## ◆ IT

const InfoType clang::doc::Info::IT = InfoType::IT_default

Definition at line 252 of file Representation.h.

Referenced by clang::doc::Generator::addInfoToIndex(), clang::doc::ClangDocBitcodeWriter::dispatchInfoForWrite(), clang::doc::HTMLGenerator::generateDocForInfo(), and mergeable().

## ◆ Name

SmallString<16> clang::doc::Info::Name

Definition at line 253 of file Representation.h.

Referenced by clang::doc::ClangDocBitcodeWriter::emitBlock(), llvm::yaml::InfoMapping(), clang::doc::serialize::parseBases(), and clang::doc::serialize::populateInfo().

## ◆ Namespace

llvm::SmallVector<Reference, 4> clang::doc::Info::Namespace

Definition at line 255 of file Representation.h.

Referenced by clang::doc::Generator::addInfoToIndex(), clang::doc::ClangDocBitcodeWriter::emitBlock(), clang::doc::serialize::emitInfo(), llvm::yaml::InfoMapping(), and clang::doc::serialize::populateInfo().

## ◆ Path

llvm::SmallString<128> clang::doc::Info::Path

Definition at line 257 of file Representation.h.

Referenced by clang::doc::Generator::addInfoToIndex(), clang::doc::ClangDocBitcodeWriter::emitBlock(), and llvm::yaml::InfoMapping().

## ◆ USR

SymbolID clang::doc::Info::USR

Initial value:
=
SymbolID()

Definition at line 250 of file Representation.h.

Referenced by clang::doc::Generator::addInfoToIndex(), clang::doc::ClangDocBitcodeWriter::emitBlock(), llvm::yaml::InfoMapping(), mergeable(), clang::doc::serialize::parseBases(), and clang::doc::serialize::populateInfo().

The documentation for this struct was generated from the following files:

- Representation.h
- Representation.cpp